'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x2, _x3, _x4) { var _again = true; _function: while (_again) { var object = _x2, property = _x3, receiver = _x4; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x2 = parent; _x3 = property; _x4 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _utils = require('./utils');

var utils = _interopRequireWildcard(_utils);

var _EventEmitter2 = require('./EventEmitter');

var _EventEmitter3 = _interopRequireDefault(_EventEmitter2);

var Connector = (function (_EventEmitter) {
  _inherits(Connector, _EventEmitter);

  function Connector(backend, cache, store, services) {
    var options = arguments.length <= 4 || arguments[4] === undefined ? {} : arguments[4];

    _classCallCheck(this, Connector);

    _get(Object.getPrototypeOf(Connector.prototype), 'constructor', this).call(this);
    this.backend = backend;
    this.cache = cache;
    this.store = store;
    this.services = services;
    this.options = options;

    this.backend.init(services, options.backend, options);
    if (this.cache) this.cache.init(services, options.cache, options);
  }

  _createClass(Connector, [{
    key: 'load',
    value: function load(languages, namespaces, callback) {
      var _this = this;

      // TODO: forces reload (evtl. just clean and load again instead of merge)
      if (typeof languages === 'string') languages = this.services.languageUtils.toResolveHierarchy(languages);
      if (typeof namespaces === 'string') namespaces = [namespaces];

      if (this.cache && this.options.cache.enabled) {
        this.cache.load(languages, function (err, data) {
          if (data) {
            for (var l in data) {
              for (var n in data[l]) {
                if (n === 'i18nStamp') continue;
                var bundle = data[l][n];
                if (bundle) _this.store.addResourceBundle(l, n, bundle);
                // TODO: if !bundle log error
              }
            }
          }
        });
      }

      if (this.options.backend.allowMultiLoading && this.backend.readMulti) {
        (function () {
          var read = function read(lng, ns, tried, wait) {
            var _this2 = this;

            if (!tried) tried = 0;
            if (!wait) wait = 250;

            this.backend.readMulti(lng, ns, function (err, data) {
              if (err && data /* = retryFlag */ && tried < 5) {
                setTimeout(function () {
                  read.call(_this2, lng, ns, tried++, wait * 2);
                }, wait);
                return;
              }

              if (data) {
                languages.forEach(function (l) {
                  namespaces.forEach(function (n) {
                    var saveN = n.replace(/\./g, '###');
                    var bundle = utils.getPath(data, l + '.' + saveN);
                    if (bundle) _this2.store.addResourceBundle(l, n, bundle);
                    // TODO: if !bundle log error
                  });
                });
              }

              if (_this2.cache && _this2.options.cache.enabled) _this2.cache.save(_this2.store.data);
              callback();
            });
          };

          var toLoadLanguages = [],
              toLoadNamespaces = [];

          languages.forEach(function (lng) {
            var hasAllNamespaces = true;
            namespaces.forEach(function (ns) {
              if (!_this.store.hasResourceBundle(lng, ns)) {
                hasAllNamespaces = false;
                if (toLoadNamespaces.indexOf(ns) < 0) toLoadNamespaces.push(ns);
              }
            });
            if (!hasAllNamespaces) toLoadLanguages.push(lng);
          });

          ;

          read.call(_this, toLoadLanguages, toLoadNamespaces);
        })();
      } else {
        var todo;

        (function () {
          var done = function done() {
            todo--;
            if (!todo) {
              if (this.cache && this.options.cache.enabled) this.cache.save(this.store.data);
              callback();
            }
          };

          var read = function read(lng, ns, tried, wait) {
            var _this3 = this;

            if (!tried) tried = 0;
            if (!wait) wait = 250;

            this.backend.read(lng, ns, function (err, data) {
              if (err && data /*retryFlag*/ && tried < 5) {
                setTimeout(function () {
                  read.call(_this3, lng, ns, tried++, wait * 2);
                }, wait);
                return;
              }

              if (data) _this3.store.addResourceBundle(lng, ns, data);
              done.call(_this3);
            });
          };

          todo = languages.length * namespaces.length;
          ;

          languages.forEach(function (lng) {
            namespaces.forEach(function (ns) {
              if (!_this.store.hasResourceBundle(lng, ns)) {
                read.call(_this, lng, ns);
              } else {
                done.call(_this);
              }
            });
          });
        })();
      }
    }
  }, {
    key: 'saveMissing',
    value: function saveMissing(languages, namespace, key, fallbackValue) {
      if (this.backend.create) this.backend.create(languages, namespace, key, fallbackValue);

      // write to store to avoid resending
      this.store.addResource(languages[0], namespace, key, fallbackValue);
    }
  }]);

  return Connector;
})(_EventEmitter3['default']);

exports['default'] = Connector;
module.exports = exports['default'];