'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _utils = require('./utils');

var utils = _interopRequireWildcard(_utils);

var _EventEmitter2 = require('./EventEmitter');

var _EventEmitter3 = _interopRequireDefault(_EventEmitter2);

var _ResourceStore = require('./ResourceStore');

var _ResourceStore2 = _interopRequireDefault(_ResourceStore);

var _Translator = require('./Translator');

var _Translator2 = _interopRequireDefault(_Translator);

var _LanguageUtils = require('./LanguageUtils');

var _LanguageUtils2 = _interopRequireDefault(_LanguageUtils);

var _PluralResolver = require('./PluralResolver');

var _PluralResolver2 = _interopRequireDefault(_PluralResolver);

var _Interpolator = require('./Interpolator');

var _Interpolator2 = _interopRequireDefault(_Interpolator);

var _BackendConnector = require('./BackendConnector');

var _BackendConnector2 = _interopRequireDefault(_BackendConnector);

var _defaults = require('./defaults');

var _postProcessor = require('./postProcessor');

var _postProcessor2 = _interopRequireDefault(_postProcessor);

var _compatibility110X = require('./compatibility/1.10.x');

var compat = _interopRequireWildcard(_compatibility110X);

var I18n = (function (_EventEmitter) {
  _inherits(I18n, _EventEmitter);

  function I18n(options, callback) {
    if (options === undefined) options = {};

    _classCallCheck(this, I18n);

    _get(Object.getPrototypeOf(I18n.prototype), 'constructor', this).call(this);
    this.options = options;
    this.services = {};

    if (callback && !this.isInitialized) this.init(options, callback);
  }

  _createClass(I18n, [{
    key: 'init',
    value: function init(options, callback) {
      var _this = this;

      if (typeof options === 'function') {
        callback = options;
        options = {};
      }
      if (options.compatibilityAPI === '1.10.x') {
        this.options = utils.defaults({}, (0, _defaults.transformOptions)(compat.convertOptions(options)), (0, _defaults.get)());
      } else {
        this.options = utils.defaults(this.options, (0, _defaults.transformOptions)(options), (0, _defaults.get)());
      }
      if (!callback) callback = function () {};

      // init services
      if (!this.options.isClone) {
        var lu = new _LanguageUtils2['default'](this.options);
        this.store = new _ResourceStore2['default'](this.options.resources, this.options);

        var s = this.services;
        s.resourceStore = this.store;
        s.languageUtils = lu;
        s.pluralResolver = new _PluralResolver2['default'](lu, { prepend: '_', compatibilityJSON: this.options.compatibilityJSON });
        s.interpolator = new _Interpolator2['default'](this.options);
        if (this.backend) s.backendConnector = new _BackendConnector2['default'](this.backend, this.cache, s.resourceStore, s, this.options);
        if (this.LanguageDetector) {
          s.languageDetector = this.LanguageDetector;
          s.languageDetector.init(s, this.options.detection);
        }

        this.translator = new _Translator2['default'](this.services, this.options);
      }

      // append api
      var storeApi = ['addResource', 'addResources', 'addResourceBundle', 'removeResourceBundle', 'hasResourceBundle', 'getResourceBundle'];
      storeApi.forEach(function (fcName) {
        _this[fcName] = function () {
          return this.store[fcName].apply(this.store, arguments);
        };
      });

      // TODO: COMPATIBILITY remove this
      if (this.options.compatibilityAPI === '1.10.x') compat.appendBackwardsAPI(this);

      this.changeLanguage(this.options.lng, callback);
    }
  }, {
    key: 'loadResources',
    value: function loadResources(callback) {
      var _this2 = this;

      if (!callback) callback = function () {};

      var done = function done(err) {
        callback(err, function () {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          return _this2.t.apply(_this2, args);
        });
      };

      if (!this.options.resources && this.services.backendConnector) {
        (function () {
          var toLoad = [];

          var append = function append(lng) {
            var lngs = _this2.services.languageUtils.toResolveHierarchy(lng);
            lngs.forEach(function (l) {
              if (toLoad.indexOf(l) < 0) toLoad.push(l);
            });
          };

          append(_this2.language);

          if (_this2.options.preload) {
            _this2.options.preload.forEach(function (l) {
              append(l);
            });
          }

          _this2.services.backendConnector.load(toLoad, _this2.options.ns, done);
        })();
      } else {
        done(null);
      }
    }
  }, {
    key: 'use',
    value: function use(module) {
      if (module.type === 'backend') {
        this.backend = module;
      }

      if (module.type === 'cache') {
        this.cache = module;
      }

      if (module.type === 'languageDetector') {
        this.LanguageDetector = module;
      }

      if (module.type === 'postProcessor') {
        _postProcessor2['default'].addPostProcessor(module);
      }

      return this;
    }

    // TODO: COMPATIBILITY remove this
  }, {
    key: 'addPostProcessor',
    value: function addPostProcessor(name, fc) {
      // TODO: deprecation warning
      this.use({
        type: 'postProcessor',
        name: name,
        process: fc
      });
    }
  }, {
    key: 'changeLanguage',
    value: function changeLanguage(lng, callback) {
      if (!lng && this.services.languageDetector) lng = this.services.languageDetector.detect();
      if (lng) {
        this.language = lng;
        this.translator.changeLanguage(lng);

        if (this.services.languageDetector) this.services.languageDetector.cacheUserLanguage(lng);
        this.emit('languageChanged', lng);
      }

      this.loadResources(callback);
    }
  }, {
    key: 'getFixedT',
    value: function getFixedT(lng) {
      var _this3 = this;

      var fixedT = function fixedT(key, options) {
        options = options || {};
        options.lng = options.lng || fixedT.lng;
        return _this3.t(key, options);
      };
      fixedT.lng = lng;
      return fixedT;
    }
  }, {
    key: 't',
    value: function t() {
      return this.translator.translate.apply(this.translator, arguments);
    }
  }, {
    key: 'exists',
    value: function exists() {
      return this.translator.exists.apply(this.translator, arguments);
    }
  }, {
    key: 'setDefaultNamespace',
    value: function setDefaultNamespace(ns) {
      this.options.defaultNS = ns;
    }
  }, {
    key: 'loadNamespaces',
    value: function loadNamespaces(ns, callback) {
      var _this4 = this;

      if (typeof ns === 'string') ns = [ns];

      ns.forEach(function (n) {
        if (_this4.options.ns.indexOf(n) < 0) _this4.options.ns.push(n);
      });

      this.loadResources(callback);
    }
  }, {
    key: 'loadLanguages',
    value: function loadLanguages(lngs, callback) {
      if (typeof lngs === 'string') lngs = [lngs];
      this.options.preload = this.options.preload ? this.options.preload.concat(lngs) : lngs;

      this.loadResources(callback);
    }
  }, {
    key: 'createInstance',
    value: function createInstance(options, callback) {
      if (options === undefined) options = {};

      return new I18n(options, callback);
    }
  }, {
    key: 'cloneInstance',
    value: function cloneInstance(options, callback) {
      var _this5 = this;

      if (options === undefined) options = {};

      var clone = new I18n(utils.extend(options, this.options, { isClone: true }), callback);
      var membersToCopy = ['store', 'translator', 'services', 'language'];
      membersToCopy.forEach(function (m) {
        clone[m] = _this5[m];
      });

      return clone;
    }
  }]);

  return I18n;
})(_EventEmitter3['default']);

exports['default'] = new I18n();
module.exports = exports['default'];